﻿Public Class CodeRecorder

	Private _IsRecording As Boolean = False
	Property IsRecording As Boolean
		Get
			Return _IsRecording
		End Get
		Private Set
			_IsRecording = Value
		End Set
	End Property

	ReadOnly Property RecordedCode As IEnumerable(Of String)
		Get
			Return RecordedCodeLines
		End Get
	End Property

	Private ReadOnly RecordedCodeLines As New List(Of String)

	Friend Sub ToggleRecordAutomationMode()
		IsRecording = Not IsRecording
	End Sub

	Private Sub RememberCodeWhileRecording(CodeLine As String)
		If Not IsRecording Then Return

		RecordedCodeLines.Add(CodeLine)
	End Sub

	Friend Sub ClearRecordedCode()
		RecordedCodeLines.Clear()
	End Sub

	Friend Sub RememberMenuClickFor(MenuItemID As Integer)
		RememberCodeWhileRecording($"PostMessage(NativeWindowHandle, &H111, {MenuItemID}, 0)")
	End Sub

	Friend Sub RememberAppStart(AppFilePath As String)
		RememberCodeWhileRecording($"Diagnostics.Process.Start(""{AppFilePath}"") 'Datei {AppFilePath} starten")
	End Sub

	Friend Sub RememberMethodInvokation(AutomationID As String, PatternName As String, MethodName As String, ParameterList As String)
		RememberCodeWhileRecording($"CurrentApp.GetFirstSubBoxWithID(""{AutomationID}"").GetPattern(Of Interop.UIAutomationClient.{PatternName}).{MethodName}({ParameterList}) 'Control-Patternaktion auslösen, ggf. Parameterwerte anpassen")
	End Sub

	Friend Sub WriteAppSelectionCode(NameOfTargetApp As String)
		Dim Prefix = NullString
		If RecordedCodeLines.None(Function(x) x.StartsWith("Dim CurrentApp = ")) Then Prefix = "Dim "
		RememberCodeWhileRecording($"Threading.Thread.Sleep(100) 'ein wenig warten, damit genug Zeit besteht, um die App entstehen zu lassen; ggf. anpassen")
		RememberCodeWhileRecording($"{Prefix}CurrentApp = IUIAWrapper.GetAllAccessibleApps.First(Function(x) x.CurrentName = ""{NameOfTargetApp}"") 'Zielapp merken")
		RememberCodeWhileRecording($"{Prefix}NativeWindowHandle = CurrentApp.CurrentNativeWindowHandle 'NativeWindowHandle für ein eventuelles Menü merken")
	End Sub

End Class