﻿Imports System.Runtime.CompilerServices
Imports Interop.UIAutomationClient

Public Module IUIAWrapper

	Public ReadOnly PossiblePatterns As New PatternDataPackList From
	{
		New PatternDataPack With {.Name = NameOf(IUIAutomationObjectModelPattern), .PropertyID = UIA_PropertyIds.UIA_IsObjectModelPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ValuePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationAnnotationPattern), .PropertyID = UIA_PropertyIds.UIA_IsAnnotationPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_AnnotationPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSynchronizedInputPattern), .PropertyID = UIA_PropertyIds.UIA_IsSynchronizedInputPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SynchronizedInputPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTextPattern2), .PropertyID = UIA_PropertyIds.UIA_IsTextPattern2AvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TextPattern2Id},
		New PatternDataPack With {.Name = NameOf(IUIAutomationStylesPattern), .PropertyID = UIA_PropertyIds.UIA_IsStylesPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_StylesPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSpreadsheetPattern), .PropertyID = UIA_PropertyIds.UIA_IsSpreadsheetPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SpreadsheetPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationVirtualizedItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsVirtualizedItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_VirtualizedItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationLegacyIAccessiblePattern), .PropertyID = UIA_PropertyIds.UIA_IsLegacyIAccessiblePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_LegacyIAccessiblePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationItemContainerPattern), .PropertyID = UIA_PropertyIds.UIA_IsItemContainerPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ItemContainerPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSpreadsheetItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsSpreadsheetItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SpreadsheetItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSelectionPattern2), .PropertyID = UIA_PropertyIds.UIA_IsSelectionPattern2AvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SelectionPattern2Id},
		New PatternDataPack With {.Name = NameOf(IUIAutomationCustomNavigationPattern), .PropertyID = UIA_PropertyIds.UIA_IsCustomNavigationPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_CustomNavigationPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTransformPattern2), .PropertyID = UIA_PropertyIds.UIA_IsTransformPattern2AvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TransformPattern2Id},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTextChildPattern), .PropertyID = UIA_PropertyIds.UIA_IsTextChildPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TextChildPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationDragPattern), .PropertyID = UIA_PropertyIds.UIA_IsDragPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_DragPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationDropTargetPattern), .PropertyID = UIA_PropertyIds.UIA_IsDropTargetPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_DropTargetPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTextEditPattern), .PropertyID = UIA_PropertyIds.UIA_IsTextEditPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TextEditPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationDockPattern), .PropertyID = UIA_PropertyIds.UIA_IsDockPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_DockPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationExpandCollapsePattern), .PropertyID = UIA_PropertyIds.UIA_IsExpandCollapsePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ExpandCollapsePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationGridItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsGridItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_GridItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationGridPattern), .PropertyID = UIA_PropertyIds.UIA_IsGridPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_GridPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationInvokePattern), .PropertyID = UIA_PropertyIds.UIA_IsInvokePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_InvokePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationRangeValuePattern), .PropertyID = UIA_PropertyIds.UIA_IsRangeValuePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_RangeValuePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationScrollPattern), .PropertyID = UIA_PropertyIds.UIA_IsScrollPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ScrollPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationScrollItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsScrollItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ScrollItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSelectionItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsSelectionItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SelectionItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationSelectionPattern), .PropertyID = UIA_PropertyIds.UIA_IsSelectionPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_SelectionPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTablePattern), .PropertyID = UIA_PropertyIds.UIA_IsTablePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TablePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTableItemPattern), .PropertyID = UIA_PropertyIds.UIA_IsTableItemPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TableItemPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTextPattern), .PropertyID = UIA_PropertyIds.UIA_IsTextPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TextPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationMultipleViewPattern), .PropertyID = UIA_PropertyIds.UIA_IsMultipleViewPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_MultipleViewPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTogglePattern), .PropertyID = UIA_PropertyIds.UIA_IsTogglePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TogglePatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationTransformPattern), .PropertyID = UIA_PropertyIds.UIA_IsTransformPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_TransformPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationWindowPattern), .PropertyID = UIA_PropertyIds.UIA_IsWindowPatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_WindowPatternId},
		New PatternDataPack With {.Name = NameOf(IUIAutomationValuePattern), .PropertyID = UIA_PropertyIds.UIA_IsValuePatternAvailablePropertyId, .PatternID = UIA_PatternIds.UIA_ValuePatternId}
	}

	Public ReadOnly IUIInterface As IUIAutomation = New CUIAutomation
	Public ReadOnly Desktop As IUIAutomationElement = IUIInterface.GetRootElement()

	Public Function GetAllAccessibleApps() As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Desktop.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreateTrueCondition))
	End Function

	<Extension> Public Function GetMethods(PatternDataPack As PatternDataPack) As IEnumerable(Of Reflection.MethodInfo)
		Dim MethodList As New List(Of Reflection.MethodInfo)
		AddMethodsTo(Of IUIAutomationObjectModelPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationAnnotationPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSynchronizedInputPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTextPattern2)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationStylesPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSpreadsheetPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationVirtualizedItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationLegacyIAccessiblePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationItemContainerPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSpreadsheetItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSelectionPattern2)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationCustomNavigationPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTransformPattern2)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTextChildPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationDragPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationDropTargetPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTextEditPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationDockPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationExpandCollapsePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationGridItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationGridPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationInvokePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationRangeValuePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationScrollPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationScrollItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSelectionItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationSelectionPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTablePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTableItemPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTextPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationMultipleViewPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTogglePattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationTransformPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationWindowPattern)(MethodList, PatternDataPack.Name)
		AddMethodsTo(Of IUIAutomationValuePattern)(MethodList, PatternDataPack.Name)
		Return MethodList
	End Function

	<Extension> Public Function GetProperties(PatternDataPack As PatternDataPack) As IEnumerable(Of String)
		Dim PropertyList As New List(Of String)
		AddPropertiesTo(Of IUIAutomationObjectModelPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationAnnotationPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSynchronizedInputPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTextPattern2)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationStylesPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSpreadsheetPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationVirtualizedItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationLegacyIAccessiblePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationItemContainerPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSpreadsheetItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSelectionPattern2)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationCustomNavigationPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTransformPattern2)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTextChildPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationDragPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationDropTargetPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTextEditPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationDockPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationExpandCollapsePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationGridItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationGridPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationInvokePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationRangeValuePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationScrollPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationScrollItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSelectionItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationSelectionPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTablePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTableItemPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTextPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationMultipleViewPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTogglePattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationTransformPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationWindowPattern)(PropertyList, PatternDataPack.Name)
		AddPropertiesTo(Of IUIAutomationValuePattern)(PropertyList, PatternDataPack.Name)
		Return PropertyList
	End Function

	Private Sub AddMethodsTo(Of T)(MethodList As List(Of Reflection.MethodInfo), CurrentPatternName As String)
		If CurrentPatternName <> GetType(T).Name Then Return

		Dim PossibleMethods = GetType(T).GetMethods(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance).Where(Function(x) Not x.IsSpecialName)
		MethodList.AddRange(PossibleMethods)
	End Sub

	Private Sub AddPropertiesTo(Of T)(PropertyList As List(Of String), CurrentPatternName As String)
		If CurrentPatternName <> GetType(T).Name Then Return

		Dim PossibleProperties = GetType(T).GetProperties(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance).Where(Function(x) Not x.IsSpecialName)
		PropertyList.AddRange(PossibleProperties.Select(Function(x) x.Name))
	End Sub

	<Extension> Public Function GetReturnValueForInvokedMethod(Control As IUIAutomationElement, MethodDataPack As MethodDataPack) As IEnumerable(Of Object)
		Dim ResultList As New List(Of Object) From {
			GetReturnValueForInvokedMethod(Of IUIAutomationObjectModelPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationAnnotationPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSynchronizedInputPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTextPattern2)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationStylesPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSpreadsheetPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationVirtualizedItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationLegacyIAccessiblePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationItemContainerPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSpreadsheetItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSelectionPattern2)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationCustomNavigationPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTransformPattern2)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTextChildPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationDragPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationDropTargetPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTextEditPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationDockPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationExpandCollapsePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationGridItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationGridPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationInvokePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationRangeValuePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationScrollPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationScrollItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSelectionItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationSelectionPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTablePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTableItemPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTextPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationMultipleViewPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTogglePattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationTransformPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationWindowPattern)(Control, MethodDataPack),
			GetReturnValueForInvokedMethod(Of IUIAutomationValuePattern)(Control, MethodDataPack)
		}
		Return ResultList.Where(Function(x) x IsNot Nothing)
	End Function

	Private Function GetReturnValueForInvokedMethod(Of T)(Control As IUIAutomationElement, MethodDataPack As MethodDataPack) As Object
		If MethodDataPack.PatternName <> GetType(T).Name Then Return Nothing

		Try
			Return GetType(T).GetMethod(MethodDataPack.MethodName).Invoke(Control.GetCurrentPattern(MethodDataPack.PatternID), MethodDataPack.ParameterValues.ToArray)
		Catch TIEx As Reflection.TargetInvocationException
			InformAbout("Die Methode konnte nicht aufgerufen werden.")
		Catch TPCEx As Reflection.TargetParameterCountException
			InformAbout("Die Methode konnte nicht korrekt aufgerufen werden; die Parameteranzahl stimmt nicht.")
		Catch AEx As ArgumentException
			InformAbout($"Die Methode konnte nicht korrekt aufgerufen werden; der Parametertyp stimmt nicht. {AEx.Message}")
		Catch UAEx As UnauthorizedAccessException
			InformAbout($"Die Methode konnte nicht korrekt aufgerufen werden; Die Box scheint wohl nicht mehr zu existieren. {UAEx.Message}")
		End Try
		Return Nothing
	End Function

	<Extension> Public Function GetValueFromSelectedProperty(Control As IUIAutomationElement, PropertyDataPack As PropertyDataPack) As IEnumerable(Of Object)
		Dim ResultList As New List(Of Object) From {
			GetValueFromSelectedProperty(Of IUIAutomationObjectModelPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationAnnotationPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSynchronizedInputPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTextPattern2)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationStylesPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSpreadsheetPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationVirtualizedItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationLegacyIAccessiblePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationItemContainerPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSpreadsheetItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSelectionPattern2)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationCustomNavigationPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTransformPattern2)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTextChildPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationDragPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationDropTargetPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTextEditPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationDockPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationExpandCollapsePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationGridItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationGridPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationInvokePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationRangeValuePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationScrollPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationScrollItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSelectionItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationSelectionPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTablePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTableItemPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTextPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationMultipleViewPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTogglePattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationTransformPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationWindowPattern)(Control, PropertyDataPack),
			GetValueFromSelectedProperty(Of IUIAutomationValuePattern)(Control, PropertyDataPack)
		}
		Return ResultList.Where(Function(x) x IsNot Nothing)
	End Function

	Private Function GetValueFromSelectedProperty(Of T)(Control As IUIAutomationElement, PropertyDataPack As PropertyDataPack) As Object
		If PropertyDataPack.PatternName <> GetType(T).Name Then Return Nothing

		Try
			Return GetType(T).GetProperty(PropertyDataPack.PropertyName).GetValue(Control.GetCurrentPattern(PropertyDataPack.PatternID))
		Catch TIEx As Reflection.TargetInvocationException
			InformAbout("Dieser Propertywert ist nicht verfügbar.")
		End Try
		Return Nothing
	End Function

	<Extension> Public Function GetFirstSubBoxWithName(Box As IUIAutomationElement, Name As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name))
	End Function

	<Extension> Public Function GetFirstSubBoxWhoseNameStartsWith(Box As IUIAutomationElement, Name As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name))
	End Function

	<Extension> Public Function GetFirstSubBoxWhoseNameContains(Box As IUIAutomationElement, Name As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name))
	End Function

	<Extension> Public Function GetFirstSubBoxWithClassName(Box As IUIAutomationElement, ClassName As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName))
	End Function

	<Extension> Public Function GetFirstSubBoxWhoseClassNameStartsWith(Box As IUIAutomationElement, ClassName As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName))
	End Function

	<Extension> Public Function GetFirstSubBoxWhoseClassNameContains(Box As IUIAutomationElement, ClassName As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName))
	End Function

	<Extension> Public Function GetFirstChildSubBoxWithID(Box As IUIAutomationElement, ID As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_AutomationIdPropertyId, ID))
	End Function

	<Extension> Public Function GetFirstSubBoxWithID(Box As IUIAutomationElement, ID As String) As IUIAutomationElement
		Return Box.FindFirst(TreeScope.TreeScope_Descendants, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_AutomationIdPropertyId, ID))
	End Function

	<Extension> Public Function GetAllSubBoxesWithName(Box As IUIAutomationElement, Name As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name)))
	End Function

	<Extension> Public Function GetAllSubBoxesWhoseNameStartsWith(Box As IUIAutomationElement, Name As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name)))
	End Function

	<Extension> Public Function GetAllSubBoxesWhoseNameContains(Box As IUIAutomationElement, Name As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_NamePropertyId, Name)))
	End Function

	<Extension> Public Function GetAllSubBoxesWithClassName(Box As IUIAutomationElement, ClassName As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName)))
	End Function

	<Extension> Public Function GetGetAllSubBoxesWhoseClassNameStartsWith(Box As IUIAutomationElement, ClassName As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName)))
	End Function

	<Extension> Public Function GetAllSubBoxesWhoseClassNameContains(Box As IUIAutomationElement, ClassName As String) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(Box.FindAll(TreeScope.TreeScope_Children, IUIInterface.CreatePropertyCondition(UIA_PropertyIds.UIA_ClassNamePropertyId, ClassName)))
	End Function

	<Extension> Public Function GetChildSubBoxes(SubBox As IUIAutomationElement) As IEnumerable(Of IUIAutomationElement)
		Return GetSubBoxesFor(SubBox, TreeScope.TreeScope_Children)
	End Function

	<Extension> Public Function GetAllSubBoxes(SubBox As IUIAutomationElement) As IEnumerable(Of IUIAutomationElement)
		Return GetSubBoxesFor(SubBox, TreeScope.TreeScope_Descendants)
	End Function

	Private Function GetSubBoxesFor(SubBox As IUIAutomationElement, Scope As TreeScope) As IEnumerable(Of IUIAutomationElement)
		Return GetListFrom(SubBox.FindAll(Scope, IUIInterface.CreateTrueCondition))
	End Function

	<Extension> Public Function GetAvailablePatterns(SubBox As IUIAutomationElement) As IEnumerable(Of PatternDataPack)
		Dim AvailablePatterns As New List(Of PatternDataPack)
		For Each PossiblePattern In PossiblePatterns
			Try
				If Not CBool(SubBox.GetCurrentPropertyValue(PossiblePattern.PropertyID)) Then Continue For

				AvailablePatterns.Add(PossiblePattern)
			Catch UAEx As UnauthorizedAccessException
			End Try
		Next
		Return AvailablePatterns
	End Function

	<Extension> Public Function GetPattern(Of T)(SubBox As IUIAutomationElement) As T
		Dim PatternObject = GetPatternFor(SubBox, GetType(T).Name)
		If PatternObject Is Nothing Then Return Nothing

		Return DirectCast(PatternObject, T)
	End Function

	Private Function GetPatternFor(SubBox As IUIAutomationElement, PatternName As String) As Object
		Dim RequestedPattern = GetPattern(PatternName)
		If Not PatternIsAvailableFor(SubBox, RequestedPattern) Then Return Nothing

		Return SubBox.GetCurrentPattern(RequestedPattern.PatternID)
	End Function

	Private Function GetPattern(PatternName As String) As PatternDataPack
		Return PossiblePatterns.First(Function(x) x.Name = PatternName)
	End Function

	Private Function PatternIsAvailableFor(SubBox As IUIAutomationElement, RequestedPattern As PatternDataPack) As Boolean
		Return CBool(SubBox.GetCurrentPropertyValue(RequestedPattern.PropertyID))
	End Function

	Public Function GetListFrom(IUIAutomationElementArray As IUIAutomationElementArray) As IEnumerable(Of IUIAutomationElement)
		Dim FinalList As New List(Of IUIAutomationElement)
		For i = 0 To IUIAutomationElementArray.Length - 1
			FinalList.Add(IUIAutomationElementArray.GetElement(i))
		Next
		Return FinalList
	End Function

	Private Sub InformAbout(Info As String)
		MessageBox.Show(Info)
	End Sub

End Module