Partial Class FrmMain

	Private ReadOnly UIWrapper As New Interop.UIAutomationClient.CUIAutomation

	Private Sub IMain_Show() Implements IMain.Show
		ListAllApps()
		ShowDialog()
	End Sub

	Private Sub BtnRefreshSubBoxes_Click(sender As Object, e As EventArgs) Handles BtnRefreshSubBoxes.Click
		ListAllFittingSubBoxes()
	End Sub

	Private Sub BtnTreatSubBoxAsMainBox_Click(sender As Object, e As EventArgs) Handles BtnTreatSubBoxAsMainBox.Click
		If BsDescendantAutomationElements.HasNoCurrent Then Return

		SetSelectedSubBoxAsCurrentMainBox()
		ActivateGoToParentBox()
	End Sub

	Private Sub BtnGoToParentBox_Click(sender As Object, e As EventArgs) Handles BtnGoToParentBox.Click
		If BsAutomationElements.HasNoCurrent Then Throw New ApplicationException("Moment. Der Button htte gar nicht aktiv sein drfen.")

		SetParentOfCurrentBoxAsNewCurrentBox()
		ClearObsoleteGuiDataContent()
		ShowDetailsForCurrentBox()
		If BsAutomationElements.HasNoCurrent Then DeactivateGoToParentBox()
	End Sub

	Private Sub BsDescendantAutomationElements_PositionChanged(sender As Object, e As EventArgs) Handles BsDescendantAutomationElements.PositionChanged
		If BsDescendantAutomationElements.HasNoCurrent Then Return

		SelectCurrentSubBoxInStructureTreeView()
	End Sub

	Private Sub BtnInvokeSelectedActionForSelectedPattern_Click(sender As Object, e As EventArgs) Handles BtnInvokeSelectedActionForSelectedPattern.Click
		If ComplainingAboutNotSelectedMethod() Then Return

		ER_WriteReturnValueIntoBox(GetReturnValueForInvokedMethod(GetMethodDataPack))
		ER_WriteMethodInvokationCode()
	End Sub

	Private Sub BtnGetPropertyValue_Click(sender As Object, e As EventArgs) Handles BtnGetPropertyValue.Click
		If ComplainingAboutNotSelectedProperty() Then Return

		ER_WriteReturnValueIntoBox(GetReturnValueForSelectedProperty(GetPropertyDataPack))
	End Sub

	Private Sub BsDescendantAutomationElements_CurrentChanged(sender As Object, e As EventArgs) Handles BsDescendantAutomationElements.CurrentChanged
		ClearPatternList()
		ListAllControlPatterns()
		ListAllProperties()
		ER_MarkSubBox()
	End Sub

	Private Sub ChbMarkBox_CheckedChanged(sender As Object, e As EventArgs) Handles ChbMarkBox.CheckedChanged
		ER_MarkSubBox()
	End Sub

	Private Sub BsPatterns_CurrentChanged(sender As Object, e As EventArgs) Handles BsPatterns.CurrentChanged
		ListPossibleMethodsForSelectedControlPattern()
		ClearPropertyList()
		ListPossiblePropertiesForSelectedPattern()
	End Sub

	Private Sub BtnClickSelectedMenuItem_Click(sender As Object, e As EventArgs) Handles BtnClickSelectedMenuItem.Click
		If NoMenuItemIsSelected() Then Return

		ER_ClickSelectedMenuItem()
		ER_WriteMenuClickCode()
	End Sub

	Private Sub BsMethodInfos_CurrentChanged(sender As Object, e As EventArgs) Handles BsPatternMethodInfos.CurrentChanged
		If BsPatternMethodInfos.HasNoCurrent Then Return

		BsParameterInfos.ReplaceListContentBy(BsPatternMethodInfos.Current.GetParameters)
	End Sub

	Private Sub TsiToggleRecordMode_Click(sender As Object, e As EventArgs) Handles TsiToggleRecordMode.Click
		ToggleRecordMode()
	End Sub

	Private Sub BsAutomationElements_CurrentChanged(sender As Object, e As EventArgs) Handles BsAutomationElements.CurrentChanged
		ClearObsoleteGuiDataContent()
		ShowDetailsForCurrentBox()
	End Sub

	Private Sub TsiStartApp_Click(sender As Object, e As EventArgs) Handles TsiStartApp.Click
		StartAppAndUpdateGui(GetAppFilePath)
	End Sub

	Private Sub TvAppStructure_AfterSelect(sender As Object, e As TreeViewEventArgs) Handles TvAppStructure.AfterSelect
		SelectCurrentSubBoxFromStructureTreeView()
	End Sub

End Class