Partial Class FrmMain

	Private Sub ListAllApps()
		BsAutomationElements.Clear()
		BsDescendantAutomationElements.ReplaceListContentBy(IUIAWrapper.GetAllAccessibleApps())
	End Sub

	Private Sub ClearDescendantsList()
		BsDescendantAutomationElements.Clear()
	End Sub

	Private Sub ListAllDescendantsOf(Box As Interop.UIAutomationClient.IUIAutomationElement)
		If BsAutomationElements.HasNoCurrent Then Return

		BsDescendantAutomationElements.Clear()
		BsDescendantAutomationElements.AddRange(Box.GetAllSubBoxes)
	End Sub

	Private Sub ListAllControlPatterns()
		If BsDescendantAutomationElements.HasNoCurrent Then Return

		BsPatterns.AddRange(BsDescendantAutomationElements.Current.GetAvailablePatterns)
	End Sub

	Private Sub ListPossibleMethodsForSelectedControlPattern()
		If BsPatterns.HasNoCurrent Then Return

		BsPatternMethodInfos.ReplaceListContentBy(BsPatterns.Current.GetMethods().ToList)
	End Sub

	Private Sub ListPossiblePropertiesForSelectedPattern()
		If BsPatterns.HasNoCurrent Then Return

		CbxPatternProperties.Items.AddRange(BsPatterns.Current.GetProperties().ToArray)
	End Sub

	Private Sub ClearPropertyTable()
		DgvControlProperties.ClearContent
	End Sub

	Private Sub ClearPropertyList()
		CbxPatternProperties.Items.Clear()
	End Sub

	Private Sub ClearPatternList()
		BsPatterns.Clear()
	End Sub

	Private Sub WritePropertyDataIntoTable(PropertyData As (Name As String, Value As String))
		DgvControlProperties.Rows.Add(PropertyData.Name, PropertyData.Value?.ToString)
	End Sub

	Private Sub AddMenuItemToTable(MenuItemData As MenuItemData)
		DgvAppMenu.Rows.Add(MenuItemData.MenuName?.Replace("&", "").Trim, MenuItemData.Title?.Replace("&", "").Trim, MenuItemData.ItemID)
	End Sub

	Private Function GetAppFilePath() As String
		OfdRunApp.ShowDialog()

		Return OfdRunApp.FileName
	End Function

	Private Sub SetSelectedSubBoxAsCurrentMainBox()
		BsAutomationElements.Clear()
		BsAutomationElements.Add(BsDescendantAutomationElements.Current)
	End Sub

	Private Sub SetParentOfCurrentBoxAsNewCurrentBox()
		Dim TreeWalker = UIWrapper.CreateTreeWalker(UIWrapper.CreateTrueCondition)
		Dim NewMainBox = TreeWalker.GetParentElement(BsAutomationElements.Current)
		BsAutomationElements.ReplaceListContentBy({NewMainBox})
	End Sub

	Private Sub SelectCurrentSubBoxInStructureTreeView()
		TvAppStructure.SelectedNode = TvAppStructure.GetAllNodes(BsDescendantAutomationElements.Position + 1)
	End Sub

	Private Sub ClearAppMenuTable()
		DgvAppMenu.ClearContent
	End Sub

	Private Sub ClearAppStructureView()
		TvAppStructure.Nodes.Clear()
	End Sub

	Private Sub DeactivateGoToParentBox()
		BtnGoToParentBox.Enabled = False
	End Sub

	Private Sub ActivateGoToParentBox()
		BtnGoToParentBox.Enabled = True
	End Sub

	Private Sub SelectCurrentSubBoxFromStructureTreeView()
		Dim TreeNodes = TvAppStructure.GetAllNodes
		For i = 0 To TreeNodes.Count - 1
			If TvAppStructure.SelectedNode Is TreeNodes(i) Then BsDescendantAutomationElements.Position = i - 1 : Return
		Next
	End Sub

	Private Sub ToggleRecordModeGuiParts()
		Me.BackColor.ToggleBetween(Drawing.Color.Salmon, Drawing.Color.White)
		TsiStartApp.Enabled.ToggleBetween(True, False)
	End Sub

	Private Sub AddNewMainNodeTo(CurrentTreeViewNode As TreeNode, SubBoxName As String)
		If CurrentTreeViewNode.Exists Then Return

		TvAppStructure.Nodes.Add(SubBoxName) : Return
	End Sub

	Private Sub AddNewSubNodeTo(CurrentTreeViewNode As TreeNode, SubBoxName As String)
		If CurrentTreeViewNode.NotExists Then Return

		CurrentTreeViewNode.Nodes.Add(SubBoxName)
	End Sub

End Class