Partial Class FrmMain

	Private Sub ClearObsoleteGuiDataContent()
		ClearAppMenuTable()
		ClearAppStructureView()
	End Sub

	Private Sub ListAllProperties()
		ClearPropertyTable()
		Dim Properties = GetAllAutomationElementProperties()
		Dim PropertyData = GetPropertyDataFrom(Properties)
		WriteAllPropertyDataIntoTable(PropertyData)
	End Sub

	Private Function GetPropertyDataFrom(Properties As IEnumerable(Of Reflection.PropertyInfo)) As IEnumerable(Of (Name As String, Value As String))
		Return Properties.SelectMany(Function(x) GetPropertyDataFor(x))
	End Function

	Private Sub WriteAllPropertyDataIntoTable(PropertyData As IEnumerable(Of (Name As String, Value As String)))
		PropertyData.ForEach(Sub(x) WritePropertyDataIntoTable(x))
	End Sub

	Private Sub StartAppAndUpdateGui(AppFilePath As String)
		If Not FilePathExists(AppFilePath) Then Return

		ER_RunExistingApp(AppFilePath)
		ER_WriteAppStartCode(AppFilePath)
		ListAllApps()
	End Sub

	Private Sub ShowDetailsForCurrentBox()
		If BsAutomationElements.HasNoCurrent Then Return

		ER_RetrieveMenuDataForSelectedApp(BsAutomationElements.Current)
		WriteMenuDataIntoGui()
		ListAllFittingSubBoxes()
		ER_WriteAppSelectionCode(BsAutomationElements.Current?.CurrentName)
	End Sub

	Private Sub WriteMenuDataIntoGui()
		ER_GetMenuItemList.MenuItems.ForEach(Sub(x) AddMenuItemToTable(x))
	End Sub

	Private Sub ListAllFittingSubBoxes()
		If CurrentMainBoxIsDesktop() Then ListAllApps() : Return

		ListAllDescendantsOf(BsAutomationElements.Current)
		WriteSubBoxDataIntoAppStructureView(BsAutomationElements.Current, Nothing)
	End Sub

	Private Sub WriteSubBoxDataIntoAppStructureView(Box As Interop.UIAutomationClient.IUIAutomationElement, CurrentTreeViewNode As TreeNode)
		AddNewNodeTo(CurrentTreeViewNode, Box.CurrentName)
		Dim LastAddedNode = GetLastNodeFor(CurrentTreeViewNode)
		Box.GetChildSubBoxes.ForEach(Sub(x) WriteSubBoxDataIntoAppStructureView(x, LastAddedNode))
	End Sub

	Private Sub AddNewNodeTo(CurrentTreeViewNode As TreeNode, NodeText As String)
		AddNewMainNodeTo(CurrentTreeViewNode, NodeText)
		AddNewSubNodeTo(CurrentTreeViewNode, NodeText)
	End Sub

	Private Sub ToggleRecordMode()
		ToggleRecordModeGuiParts()
		ER_ToggleCodeRecordingMode()
		StopRecordingMode()
	End Sub

	Private Sub StopRecordingMode()
		If CodeRecorderIsActive() Then Return

		ER_MoveRecordedCodeIntoClipboard()
		ER_ClearRecordedCode()
		InformAbout("Der generierte Code wurde in die Zwischenablage kopiert.")
	End Sub

End Class