Partial Class VmMain

	Private Sub WireEvents()
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.RetrieveMenuDataForSelectedApp), NameOf(RetrieveMenuDataForSelectedApp))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.WriteMenuClickCode), NameOf(WriteMenuClickCode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.ClickSelectedMenuItem), NameOf(ClickSelectedMenuItem))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.WriteMethodInvokationCode), NameOf(WriteMethodInvokationCode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.WriteAppSelectionCode), NameOf(WriteAppSelectionCode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.WriteReturnValueIntoBox), NameOf(InformAboutReturnValues))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.RunExistingApp), NameOf(RunExistingApp))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.WriteAppStartCode), NameOf(WriteAppStartCode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.ToggleCodeRecordingMode), NameOf(ToggleCodeRecordingMode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.MoveRecordedCodeIntoClipboard), NameOf(MoveRecordedCodeIntoClipboard))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.ClearRecordedCode), NameOf(ClearRecordedCode))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.GetMenuItemList), NameOf(GetMenuItemList))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.CodeRecorderIsRecording), NameOf(CodeRecorderIsRecording))
		EventPacks.AddEventHandlerTo(UI, Me, NameOf(IMain.MarkSubBox), NameOf(MarkSubBox))
		EventPacks.ActivateAllEventHandlers()
	End Sub

	Private Sub ShowUI()
		UI.Show()
	End Sub

	Private Sub UnwireEvents()
		EventPacks.DeactivateAllEventHandlers()
		EventPacks.Clear()
	End Sub

	Private Sub ToggleCodeRecordingMode()
		CodeRecorder.ToggleRecordAutomationMode()
	End Sub

	Private Sub ClearRecordedCode()
		CodeRecorder.ClearRecordedCode()
	End Sub

	Private Sub WriteMenuClickCode(MenuItemID As Integer)
		CodeRecorder.RememberMenuClickFor(MenuItemID)
	End Sub

	Private Sub WriteMethodInvokationCode(SelectedAutomationID As String, PatternName As String, MethodName As String, ParameterList As String)
		CodeRecorder.RememberMethodInvokation(SelectedAutomationID, PatternName, MethodName, ParameterList)
	End Sub

	Private Sub WriteAppStartCode(AppFilePath As String)
		CodeRecorder.RememberAppStart(AppFilePath)
	End Sub

	Private Sub WriteAppSelectionCode(AppName As String)
		CodeRecorder.WriteAppSelectionCode(AppName)
	End Sub

	Private Sub ClickSelectedMenuItem(WindowHandle As IntPtr, MenuItemID As Integer)
		PostMessage(WindowHandle, &H111, MenuItemID, 0)
	End Sub

	Private Sub RunExistingApp(FilePath As String)
		Diagnostics.Process.Start(FilePath)
	End Sub

	Private Sub MarkSubBox(Rectangle As Rectangle)
		Dim DcHandle = GetDC(IntPtr.Zero)
		Using Graphics = Drawing.Graphics.FromHdc(DcHandle)
			Graphics.DrawRectangle(Drawing.Pens.Red, Rectangle.Left, Rectangle.Top, Rectangle.Right - Rectangle.Left, Rectangle.Bottom - Rectangle.Top)
		End Using
		ReleaseDC(IntPtr.Zero, DcHandle)
	End Sub

	Private Sub InformAboutExistingReturnValues(ReturnValueText As String)
		If Not WritingReturnValueTextIntoClipboardIsDesired(ReturnValueText) Then Return

		Clipboard.SetText(ReturnValueText)
	End Sub

	Private Sub MoveExistingRecordedCodeIntoClipboard(RecordedCode As String)
		If RecordedCode.IsEmpty Then Clipboard.Clear() : Return

		Clipboard.SetText(RecordedCode)
	End Sub

	Private Sub RetrieveMenuDataForSelectedApp(App As Interop.UIAutomationClient.IUIAutomationElement)
		MenuItemList.RetrieveMenuItemsFor(App)
	End Sub

End Class